# enable_gtkdoc: Toggle if gtk-doc files should be rebuilt.
#      0 = no
#      1 = yes
%define enable_gtkdoc 0

# enable_bootstrap: Toggle if bootstrapping package
#      0 = no
#      1 = yes
%define enable_bootstrap 0

# enable_tests: Run test suite in build
#      0 = no
#      1 = yes
%define enable_tests 0

%{?_without_gtkdoc: %{expand: %%define enable_gtkdoc 0}}
%{?_without_bootstrap: %{expand: %%define enable_bootstrap 0}}
%{?_without_tests: %{expand: %%define enable_tests 0}}

%{?_with_gtkdoc: %{expand: %%define enable_gtkdoc 1}}
%{?_with_bootstrap: %{expand: %%define enable_bootstrap 1}}
%{?_with_tests: %{expand: %%define enable_tests 1}}

# required version of various libraries
%define req_glib_version		2.31.18
%define req_pango_version		1.29.0
%define req_atk_version			2.1.5
%define req_cairo_version		1.10.0
%define req_gdk_pixbuf_version		2.25.2

%define pkgname			gtk+
%define api			3
%define api_version		3.0
%define binary_version		3.0.0
%define lib_major		0
%define libname			%mklibname %{pkgname} %{api} %{lib_major}
%define girname			%mklibname gtk-gir %{api_version}
%define develname		%mklibname -d %{pkgname} %{api_version}

%define gail_major 0
%define gail_libname %mklibname gail %{api} %{gail_major}
%define gaildevelname %mklibname -d gail %{api_version}

%define url_ver	%(echo %{version}|cut -d. -f1,2)

Summary:	The GIMP ToolKit (GTK+), a library for creating GUIs
Name:		%{pkgname}%{api_version}
Version:	3.6.4
%define subrel	1
Release:	%mkrel 1
License:	LGPLv2+
Group:		System/Libraries
Source0:	http://download.gnome.org/sources/%{pkgname}/%{url_ver}/%{pkgname}-%{version}.tar.xz
Source1:        im-cedilla.conf
# use oxygen gtk3 theme by default if available
Patch12:        gtk+-defaulttheme.patch
Patch20:	gtk+-3.6.4-fix-configure-flag-around-cairo-egl-support.patch
Patch21:	gtk+-3.6.4-embedded-svg.patch
URL:		http://www.gtk.org
Requires:	common-licenses
BuildRequires:	gettext-devel
Buildrequires:	gtk-doc
BuildRequires:	pkgconfig(glib-2.0) >= 2.31.14
BuildRequires:	pkgconfig(atk) >= 2.1.5
BuildRequires:	pkgconfig(atk-bridge-2.0)
BuildRequires:	pkgconfig(pango) >= 1.29.0
BuildRequires:	pkgconfig(cairo) >= 1.10.0
BuildRequires:	pkgconfig(cairo-gl)
BuildRequires:	pkgconfig(cairo-gobject) >= 1.10.0
BuildRequires:	pkgconfig(cairo-xlib)
BuildRequires:	pkgconfig(gdk-pixbuf-2.0) >= 2.25.2
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xext)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xrandr) >= 1.2.99
BuildRequires:	pkgconfig(xcursor)
BuildRequires:	pkgconfig(xfixes)
BuildRequires:	pkgconfig(xi)
BuildRequires:	pkgconfig(xcomposite)
BuildRequires:	pkgconfig(xdamage)
BuildRequires:	pkgconfig(colord) >= 0.1.9
BuildRequires:	pkgconfig(xkbcommon) >= 0.2.0
BuildRequires:	pkgconfig(wayland-client) >= 1.0.0
BuildRequires:	pkgconfig(wayland-egl)
BuildRequires:  gobject-introspection-devel >= 0.10.1
BuildRequires:  cups-devel
BuildRequires:	libxi-devel
#gw needed for gtk-update-icon-cache in gtk+3.0 3.0.9
BuildRequires:	gtk+2.0

%if %enable_tests
BuildRequires:	x11-server-xvfb
%endif

%if %enable_gtkdoc
BuildRequires:	gtk-doc >= 0.9
BuildRequires:	sgml-tools
BuildRequires:	texinfo
%endif

# gw tests will fail without this
BuildRequires:	fonts-ttf-dejavu

%if !%{enable_bootstrap}
Suggests:	xdg-user-dirs-gtk
Suggests:	oxygen-gtk3
%endif

Requires:	%{libname} = %{version}
Obsoletes:	gtk-engines3 < 3.0.0
Provides:	%{pkgname}%{api} = %{version}-%{release}

%description
The gtk+ package contains the GIMP ToolKit (GTK+), a library for creating
graphical user interfaces for the X Window System.  GTK+ was originally
written for the GIMP (GNU Image Manipulation Program) image processing
program, but is now used by several other programs as well.  

If you are planning on using the GIMP or another program that uses GTK+,
you'll need to have the gtk+ package installed.

%files -f gtk30.lang
%defattr(-, root, root)
%doc README
%{_bindir}/gtk-query-immodules-%{api_version}-*
%{_bindir}/gtk-launch
%{_mandir}/man1/gtk-query-immodules-%{api_version}.1*
%{_mandir}/man1/gtk-launch.1*
%{_datadir}/themes
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.FileChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.ColorChooser.gschema.xml
%dir %{_sysconfdir}/gtk-%{api_version}
%config(noreplace) %{_sysconfdir}/gtk-%{api_version}/im-multipress.conf
%{_sysconfdir}/X11/xinit/xinput.d/im-cedilla.conf

#--------------------------------------------------------------------

%package -n %{libname}
Summary:	%{summary}
Group:		%{group}
Provides:	lib%{pkgname}%{api} = %{version}-%{release}
Provides:	lib%{name} = %{version}-%{release}
Obsoletes:	%{_lib}gtk+3.0_0 < 3.0.0
Obsoletes:	%{_lib}gtk+-x11-3.0_0 < 3.0.0
Obsoletes:	%{_lib}gtk-engines3 < 3.0.0
Requires:	libglib2.0 >= %{req_glib_version}
Requires:	libpango1.0 >= %{req_pango_version}
Requires:	libatk1.0 >= %{req_atk_version}
Requires:	gtk+3.0 = %{version}-%{release}
Requires:	glib2.0-common
Requires(post):	gtk+3.0

%description -n %{libname}
This package contains the library needed to run programs dynamically
linked with gtk+.

%post -n %{libname}
if [ "$1" = "2" ]; then
        if [ -f %{_sysconfdir}/gtk-%{api_version}/gtk.immodules ]; then
                rm -f %{_sysconfdir}/gtk-%{api_version}/gtk.immodules
        fi
fi
%{_bindir}/gtk-query-immodules-3.0-%{__isa_bits} --update-cache

%files -n %{libname}
%defattr(-, root, root)
%doc README
%ghost %verify (not md5 mtime size) %_libdir/gtk-%{api_version}/3.0.0/immodules.cache
%dir %{_libdir}/gtk-%{api_version}
%dir %{_libdir}/gtk-%{api_version}/modules
%dir %{_libdir}/gtk-%{api_version}/%{binary_version}
%dir %{_libdir}/gtk-%{api_version}/%{binary_version}/immodules
%{_libdir}/gtk-%{api_version}/%{binary_version}/immodules/*.so
%dir %{_libdir}/gtk-%{api_version}/%{binary_version}/printbackends
%{_libdir}/gtk-%{api_version}/%{binary_version}/printbackends/*.so
%{_libdir}/libgtk-3.so.%{lib_major}
%{_libdir}/libgtk-3.so.%{lib_major}.*
%{_libdir}/libgdk-3.so.%{lib_major}
%{_libdir}/libgdk-3.so.%{lib_major}.*

#--------------------------------------------------------------------

%package -n %{girname}
Summary:	GObject introspection interface library for %{name}
Group:		System/Libraries
Requires:	%{libname} = %{version}-%{release}

%description -n %{girname}
GObject introspection interface library for %{name}.

%files -n %{girname}
%{_libdir}/girepository-1.0/Gdk-%{api_version}.typelib
%{_libdir}/girepository-1.0/GdkX11-%{api_version}.typelib
%{_libdir}/girepository-1.0/Gtk-%{api_version}.typelib

#--------------------------------------------------------------------

%package -n %{develname}
Summary:	Development files for GTK+ (GIMP ToolKit) applications
Group:		Development/GNOME and GTK+
Provides:	%{pkgname}%{api}-devel = %{version}-%{release}
Provides:	lib%{pkgname}%{api}-devel = %{version}-%{release}
Provides:	lib%{pkgname}%{api_version}-devel = %{version}-%{release}
Provides:	lib%{pkgname}-x11-%{api_version}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Requires:	%{libname} = %{version}
Requires:	libgdk_pixbuf2.0-devel >= %req_gdk_pixbuf_version
Requires:	libatk1.0-devel >= %{req_atk_version}
Requires:	libpango1.0-devel >= %{req_pango_version}

%description -n %{develname}
The libgtk+-devel package contains the static libraries and header files
needed for developing GTK+ (GIMP ToolKit) applications. The libgtk+-devel
package contains GDK (the General Drawing Kit, which simplifies the interface
for writing GTK+ widgets and using GTK+ widgets in applications), and GTK+
(the widget set).

%files -n %{develname}
%defattr(-, root, root)
%doc docs/*.txt AUTHORS ChangeLog NEWS* README*
%doc %{_datadir}/gtk-doc/html/gdk3
%doc %{_datadir}/gtk-doc/html/gtk3
%{_bindir}/gtk3-demo
%{_bindir}/gtk3-demo-application
%{_bindir}/gtk3-widget-factory
%{_datadir}/glib-2.0/schemas/org.gtk.Demo.gschema.xml
%{_datadir}/aclocal/*
%{_datadir}/gtk-%{api_version}
%{_includedir}/gtk-%{api_version}
%{_libdir}/libgtk-%{api}.so
%{_libdir}/libgdk-%{api}.so
%{_libdir}/pkgconfig/gdk-*%{api_version}.pc
%{_libdir}/pkgconfig/gtk+-*%{api_version}.pc
%_datadir/gir-1.0/Gdk-%{api_version}.gir
%_datadir/gir-1.0/GdkX11-%{api_version}.gir
%_datadir/gir-1.0/Gtk-%{api_version}.gir

#--------------------------------------------------------------------

%package -n %{gail_libname}
Summary:	GNOME Accessibility Implementation Library
Group:		System/Libraries
Provides:	libgail = %{version}-%{release}
Obsoletes:	%{_lib}gail3.0_0 < 3.0.0

%description -n %{gail_libname}
Gail is the GNOME Accessibility Implementation Library

%files -n %gail_libname
%defattr(-,root,root)
%{_libdir}/libgailutil-%{api}.so.%{gail_major}*

#--------------------------------------------------------------------

%package -n %gaildevelname
Summary:	Static libraries, include files for GAIL
Group:		Development/GNOME and GTK+
Provides:	libgail-%{api_version}-devel = %{version}-%{release}
Requires:	%{gail_libname} = %{version}

%description -n %gaildevelname
Gail is the GNOME Accessibility Implementation Library

%files -n %gaildevelname
%defattr(-,root,root)
%{_datadir}/gtk-doc/html/gail-libgail-util3
%{_libdir}/libgailutil-%{api}.so
%{_includedir}/gail-%{api_version}
%{_libdir}/pkgconfig/gail-%{api_version}.pc

#--------------------------------------------------------------------

%prep
%setup -qn %{pkgname}-%{version}

%if !%{enable_bootstrap}
%patch12 -p1 -b .defaulttheme
%endif

%patch20 -p1 -b .cairo-egl
%patch21 -p1 -b .embedded-svg

%build
NOCONFIGURE=1 ./autogen.sh
(if ! test -x configure; then NOCONFIGURE=1 ./autogen.sh; CONFIGFLAGS=--enable-gtk-doc; fi;
 %configure2_5x $CONFIGFLAGS \
        --enable-gtk2-dependency \
        --enable-xkb \
        --enable-xinerama \
        --enable-xrandr \
        --enable-xfixes \
        --enable-xcomposite \
        --enable-xdamage \
        --enable-x11-backend \
	--enable-broadway-backend \
	--enable-wayland-backend \
	--disable-wayland-cairo-gl \
)

# fight unused direct deps
sed -i -e 's/ -shared / -Wl,-O1,--as-needed\0/g' libtool

%make

%check
%if %enable_tests
XDISPLAY=$(i=1; while [ -f /tmp/.X$i-lock ]; do i=$(($i+1)); done; echo $i)
%{_bindir}/Xvfb :$XDISPLAY &
export DISPLAY=:$XDISPLAY
make check
kill $(cat /tmp/.X$XDISPLAY-lock) ||:
%endif

%install
%makeinstall_std RUN_QUERY_IMMODULES_TEST=false RUN_QUERY_LOADER_TEST=false

touch $RPM_BUILD_ROOT%_libdir/gtk-%{api_version}/%{binary_version}/immodules.cache
mkdir -p $RPM_BUILD_ROOT%{_libdir}/gtk-%{api_version}/modules

(cd $RPM_BUILD_ROOT%{_bindir}
 mv gtk-query-immodules-3.0 gtk-query-immodules-3.0-%{__isa_bits}
)

# Input method frameworks want this
install -D %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit/xinput.d/im-cedilla.conf
%{find_lang} gtk30 gtk30 gtk30-properties

#remove not packaged files
find %{buildroot} -name *.la | xargs rm
rm -f $RPM_BUILD_ROOT%_mandir/man1/gtk-update-icon-cache.1*


%changelog
* Thu Dec 26 2013 luigiwalser <luigiwalser> 3.6.4-1.1.mga3
+ Revision: 560861
- add patch from opensuse to workaround librsvg security fix (mga#11853)

* Sun Apr 07 2013 wally <wally> 3.6.4-1.mga3
+ Revision: 408874
- add patch to fix build with --disable-wayland-cairo-gl which fixes build with new mesa 9.0.1 (bgo#688534)

  + ovitters <ovitters>
    - new version 3.6.4
    - drop merged wayland patches

* Mon Nov 19 2012 fwang <fwang> 3.6.2-4.mga3
+ Revision: 319588
- cleanup post requires

* Sun Nov 18 2012 fwang <fwang> 3.6.2-3.mga3
+ Revision: 319261
- enable wayland but disable cairo-gl

* Sun Nov 18 2012 fwang <fwang> 3.6.2-2.mga3
+ Revision: 319257
- completely disable wayland backend
- more check
- disable egl build till gnomebug#688534 be fixed
- rebuild for new wayland

* Sun Nov 11 2012 fwang <fwang> 3.6.2-1.mga3
+ Revision: 316920
- new version 3.6.2

* Wed Oct 31 2012 blino <blino> 3.6.1-3.mga3
+ Revision: 311691
- merge upstream patches to enable back wayland backend

* Fri Oct 19 2012 fwang <fwang> 3.6.1-2.mga3
+ Revision: 308072
- disable wayland bacakend for gdk till gnome bug#686313 be fixed
- cleanup spec
- rebuild for new wayland

* Tue Oct 16 2012 ovitters <ovitters> 3.6.1-1.mga3
+ Revision: 307113
- new version 3.6.1

* Tue Sep 25 2012 ovitters <ovitters> 3.6.0-1.mga3
+ Revision: 297361
- new version 3.6.0

* Wed Sep 19 2012 ovitters <ovitters> 3.5.18-1.mga3
+ Revision: 296031
- new version 3.5.18

* Wed Sep 05 2012 ovitters <ovitters> 3.5.16-1.mga3
+ Revision: 288384
- new version 3.5.16

* Tue Sep 04 2012 ovitters <ovitters> 3.5.14-1.mga3
+ Revision: 287817
- new version 3.5.14

* Tue Aug 21 2012 ovitters <ovitters> 3.5.12-1.mga3
+ Revision: 282824
- new version 3.5.12

* Tue Aug 07 2012 ovitters <ovitters> 3.5.10-1.mga3
+ Revision: 279645
- new version 3.5.10

* Wed Jul 25 2012 blino <blino> 3.5.8-2.mga3
+ Revision: 274153
- enable broadway (HTML5) backend
- enable wayland backend over cairo-gl

* Mon Jul 16 2012 ovitters <ovitters> 3.5.8-1.mga3
+ Revision: 271502
- update file list
- new version 3.5.8

* Tue Jun 26 2012 fwang <fwang> 3.5.6-1.mga3
+ Revision: 263822
- add br on atk-bridge

  + ovitters <ovitters>
    - new version 3.5.6

* Mon Jun 25 2012 ovitters <ovitters> 3.5.4-1.mga3
+ Revision: 263699
- new version 3.5.4

* Sat May 12 2012 ovitters <ovitters> 3.4.3-1.mga3
+ Revision: 235383
- new version 3.4.3

* Sat Apr 21 2012 ovitters <ovitters> 3.4.1-2.mga2
+ Revision: 232298
- rebuild for broken signature in lib64gail3.0-devel-3.4.1-1.mga2

* Sat Apr 14 2012 ovitters <ovitters> 3.4.1-1.mga2
+ Revision: 230773
- rediff patch
- new version 3.4.1

* Fri Apr 06 2012 dmorgan <dmorgan> 3.4.0-2.mga2
+ Revision: 228828
- Make sure gtk+3.0 is installed first ( mga #5246)

* Mon Mar 26 2012 ovitters <ovitters> 3.4.0-1.mga2
+ Revision: 226693
- new version 3.4.0

* Tue Mar 20 2012 ovitters <ovitters> 3.3.20-1.mga2
+ Revision: 225083
- new version 3.3.20
- update patch 12

* Tue Mar 06 2012 fwang <fwang> 3.3.18-1.mga2
+ Revision: 219670
- new version 3.3.18

* Fri Mar 02 2012 ovitters <ovitters> 3.3.16-1.mga2
+ Revision: 216875
- update file list
- update buildrequires
- new version 3.3.16

* Tue Feb 07 2012 fwang <fwang> 3.3.14-1.mga2
+ Revision: 205676
- bump req

* Wed Feb 01 2012 fwang <fwang> 3.3.12-1.mga2
+ Revision: 203822
- update file list
- new version 3.3.12

* Mon Jan 23 2012 tv <tv> 3.3.10-2.mga2
+ Revision: 200362
- requires glib2.0-common instead of in basesystem

* Sat Jan 21 2012 fwang <fwang> 3.3.10-1.mga2
+ Revision: 198972
- bump req
- upload tarball

  + ovitters <ovitters>
    - new version

* Tue Jan 17 2012 ovitters <ovitters> 3.3.8-1.mga2
+ Revision: 197365
- update file list
- new version

* Wed Jan 04 2012 ovitters <ovitters> 3.3.6-2.mga2
+ Revision: 190786
- rebuild to fix missing set_app_menu in gobject instrospection

* Tue Dec 20 2011 fwang <fwang> 3.3.6-1.mga2
+ Revision: 184685
- drop merged patches
- new version 3.3.6

* Sun Dec 04 2011 wally <wally> 3.3.4-2.mga2
+ Revision: 175911
- add P0 from upstream git to fix programs segfaulting when using filechooser (mga#3595)

* Tue Nov 22 2011 fwang <fwang> 3.3.4-1.mga2
+ Revision: 170719
- rediff gtk theme patch
- new version 3.3.4

* Fri Oct 28 2011 wally <wally> 3.3.2-1.mga2
+ Revision: 159246
- new version 3.3.2

* Sat Oct 15 2011 wally <wally> 3.2.1-1.mga2
+ Revision: 155285
- new version 3.2.1

* Mon Sep 26 2011 fwang <fwang> 3.2.0-1.mga2
+ Revision: 147965
- new versio 3.2.0

* Tue Sep 20 2011 fwang <fwang> 3.1.92-1.mga2
+ Revision: 145814
- new version 3.1.92

* Wed Sep 14 2011 fwang <fwang> 3.1.90-1.mga2
+ Revision: 143124
- new version 3.1.90

* Sat Sep 10 2011 fwang <fwang> 3.1.18-2.mga2
+ Revision: 142173
- rebuild for new libpng

* Tue Sep 06 2011 fwang <fwang> 3.1.18-1.mga2
+ Revision: 139032
- new version 3.1.18

* Tue Aug 30 2011 fwang <fwang> 3.1.16-1.mga2
+ Revision: 136726
- new version 3.1.16
- new version 3.1.14
- new version 3.1.12
- update req
- update file list
- new version 3.1.10

  + cjw <cjw>
    - replace patch13 with a patch from gnome git

* Thu Jul 21 2011 cjw <cjw> 3.1.8-5.mga2
+ Revision: 127624
- patch13: less crashes with glib 2.29.12

* Thu Jul 07 2011 dmorgan <dmorgan> 3.1.8-4.mga2
+ Revision: 119786
- Rebuild against new rpm-setup

* Thu Jul 07 2011 cjw <cjw> 3.1.8-3.mga2
+ Revision: 119572
- put gobject introspection typelibs in a separate subpackage

* Thu Jul 07 2011 fwang <fwang> 3.1.8-2.mga2
+ Revision: 119571
- rebuild for typelib rpm provides

* Wed Jul 06 2011 dmorgan <dmorgan> 3.1.8-1.mga2
+ Revision: 119392
- New version 3.1.8
- Fix default theme

* Mon Jul 04 2011 wally <wally> 3.1.6-1.mga2
+ Revision: 118053
- new version 3.1.6
- use configure2_5x macro
- disable bootstrapping
- include patch unconditionally and apply it conditionally

* Tue Jun 21 2011 ahmad <ahmad> 3.0.11-8.mga2
+ Revision: 111553
- In the lib package, add a requires(pre) on the main package

* Tue Jun 21 2011 ahmad <ahmad> 3.0.11-7.mga2
+ Revision: 111269
- Drop the %%post scriptlet from the main package, the glib one is handled by
  an rpm filetrigger, and the gtk-query-immodules-3.0* already exists in the
  lib package

* Mon Jun 13 2011 ahmad <ahmad> 3.0.11-6.mga2
+ Revision: 105931
- Move the gtk-query-immodules executable to the main package

* Sat Jun 11 2011 cjw <cjw> 3.0.11-5.mga2
+ Revision: 103472
- add missing dep on gtk+3.0 to library package

* Thu Jun 09 2011 dmorgan <dmorgan> 3.0.11-4.mga2
+ Revision: 102517
- Do not package libgailutil-3.la

* Tue Jun 07 2011 dmorgan <dmorgan> 3.0.11-3.mga2
+ Revision: 101655
- More fixed for %%post

* Tue Jun 07 2011 dmorgan <dmorgan> 3.0.11-2.mga2
+ Revision: 101639
- Fix %%post

* Tue Jun 07 2011 dmorgan <dmorgan> 3.0.11-1.mga2
+ Revision: 101505
- Revert rpm5 stuffs and sync with fedora
- Add missing patch

  + saispo <saispo>
    - imported package gtk+3.0

